Redmine - Feature #279

issue dependencies
2007-02-28 14:14 - Jason Huebel

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour

Target version:

Resolution: Fixed

Description

First, redMine is great as it is already. Within 10 minutes of setting it up, it's become an invaluable tool.

As for my feature request, it would helpful if you could set dependencies for issues. That is, issues could be dependent
on each other. If a main issue has dependencies, then the dependencies must all be resolved, rejected or closed before
the main issue can be resolved, rejected or closed.

If that's too complicated for now, then simple dependency tracking would work too.

Related issues:

Related to Redmine - Feature #2448: Graphviz of ticket dependencies (with exa... New 2009-01-06
Related to Redmine - Defect #1740: Actually block issues from closing when re... Closed 2008-08-04
History

#1 - 2007-02-28 14:45 - Jean-Philippe Lang

Hi,

Thanks for your interest. Issue dependencies is an important
feature and it should be added in one the upcoming releases.
I'll try to provide a roadmap as soon as possible.

Best regards,
Jean-Philippe

#2 - 2007-03-01 11:29 - Tim Rohde

Dependencies are critical for any decently large project. Without
dependencies and the ability to shift the times for all downstream
work, the user is left to manually alter all the times each time
there is a change. That is not practical on anything but toy
projects.

#3 - 2007-03-01 11:32 - Tim Rohde

BTW - Did | mention that Redmine is beautiful and was incredibily
easy to setup?!

#4 - 2007-03-01 12:46 - Jean-Philippe Lang

Hi Tim,

Thanks for your last comment :-)

I know this feature is critical. A few weeks ago, | started to
code what you ask (end/start, end/end ... dependencies) with
automatic shifting.

This feature is not yet stable or even finished but it should
be added in a near future.

Regards

#5 - 2007-03-02 11:01 - Pablo Lerina

Hi Jean!

These codes are in trunk? | would like to help with this issue!

thanks.
#6 - 2007-03-06 06:14 - Jean-Philippe Lang

No, these codes haven't been committed in trunk.
There's some code in the work branch but i'm not sure it's a
good starting point.

#7 - 2007-04-04 16:33 - Laran Evans

+1 for this one from me. | use JIRA primarily at work and we
couldn't get our job done without the ability to link issues.

#8 - 2007-04-13 06:16 - Jean-Claude REPETTO

J'appuie cette demande. C'est une fonction indispensable pour

gAfAGrer les tAfAcches d'un projet.Le dAfA@but d'une tAfA¢che doit pouvoir

dAfA@pendre de la fin d'une ou plusieurs autres tAfA¢ches.

#9 - 2007-05-01 07:27 - Nikolay Solakov

| was just looking if there is someone asking for issue dependencies
and found that request :)
| vote for it with the two hands :)

This is very important, especialy for big enterprise projects
| am working on...

Thanks!
I'm waiting now.

#10 - 2007-05-05 09:27 - Jean-Philippe Lang

Commit 506 adresses this feature. It's not finished yet.

If you want to have a try, just update your installation and

set the permissions for adding and removing relations. Commit
message follows. Any feedback is welcome.

Issue relations first commit (not thoroughly tested). 4 kinds
of relation are available:

e relates to: do nothing special. Just to know that the 2 issues
are related...

¢ duplicates: will close the related issue with the same status

when closing the issue (not implemented yet)

blocks: will require to close the blocking issue before closing

the blocked issue (not implemented yet)

precedes (end to start relation): start date of the related

issue depends on the due date of the preceding issue (implemented).

A delay can be set so that the related issue can only start n
days after the end of the preceding issue. When setting dates
for an issue, dates of all downstream issues are set according
to these relations.

To set a relation, the 2 issues have to belong to the same project
(may change in the future). So if an issue is moved to another
project, all its relations are removed.

Circular dependencies are checked when creating a relation.

#11 - 2007-05-05 18:49 - Nikolay Solakov

Hello,

| tried it. Very good work!

Here it is something related to the implemented "precedes”
feature

(not very good in english, so explaining a lot :) ) :

1. Principle of action: When | set the precedes of

issue1 to issue2 - practicly | don't care what are the
dates(begin,due) of

issue2 - | just consider that issue2 will start after the

delay

when issuel is closed(once set, the dates are irreversible,
we are building a tree). If | consider to take off the

relation-

well, | should edit the dates of issue2.

2. Should be done(maybe just missed): When | set the delay for
example 10 days,

the start date of issue2 is set properly. But then after
editing issue1 and

setting the delay for example 5 days, issue2 continues to

start after 10days.

3. The due_date of issue2 should be set to nothing if it's empty
or

to the proper delay (I think this is implemented).

Thanks,
Nikolay

#12 - 2008-01-03 14:07 - Mark Elrod

+1

#13 - 2008-05-12 18:09 - gabriel scolan

To complement the feature, wouldn't it be interesting to :

- set the relation "duplicate" automatically while making a "copy" of an issue ?
- display a dependency graph of related issues ?

It is minor but could help :-)

gabriel

#14 - 2008-06-20 00:26 - Roger Rogers

Jean-Philippe Lang wrote:

Commit 506 adresses this feature. It's not finished yet.

If you want to have a try, just update your installation and

set the permissions for adding and removing relations. Commit
message follows. Any feedback is welcome.

Is this feature still actively in development? Just curious, and would love to see the task dependency/Gantt chart features improved.

#15 - 2008-08-05 16:42 - Mischa The Evil

| noticed that my feature-request (#1740) is somehow related to this older request.

Regarding the implementation of a dependency-graph which | really think will be an great function. | have some working-experience using Flyspray
which uses WebDot and Graphviz to render linkable graphs of related issues and it really helps maintaining the overview of bigger amounts of
(nested) related issues.

Though | don't know if that's an option using Ruby on Rails.

#16 - 2009-08-31 10:47 - jason axelson

| am also wondering if anyone is still working on this?

#17 - 2009-12-02 10:55 - David Leuschner

Redmine seems great, but as long as this feature is missing, we'll stick to Bugzilla although we'd really like to switch to Redmine. Is this request still
considered important? It's already over 2 years old.

#18 - 2010-01-20 02:54 - Hugo Ferreira
David Leuschner wrote:
Redmine seems great, but as long as this feature is missing, we'll stick to Bugzilla although we'd really like to switch to Redmine. s this request

still considered important? It's already over 2 years old.

| suspect its this issue log that is long due of an update, rather than the functionality being missing. I've just been evaluating Redmine version 0.9.0
and this works flawlessly:

Issue 1 "related to" Issue 2 --causes—-—> Issue 2 "related to" Issue 1
Issue 1 "blocks" Issue 2 -—-causes—-—-> Issue 2 "blocked by" Issue 1
Issue 1 "duplicates" Issue 2 --causes——> Issue 2 "duplicated by" Issue 1
Issue 1 "precedes" Issue 2 -—-causes——> Issue 2 "follows" Issue 1
Issue 1 "follows" Issue 2 -—-causes——> Issue 2 "precedes" Issue 1

Furthermore, the follows/precedes relationship will also touch the start/due dates according to the delay set.

#19 - 2010-01-20 10:48 - Felix Schéfer

- Category set to Issues
https://www.redmine.org/issues/1740

Hugo, you are right that what I'd call "lazy relationships", i.e. relationships that only link issues to one another and don't enforce anything (the
exception being follows/precedes), are implemented, and afaik that's what bugzilla has to offer to. This request has a broader scope though, and calls
for harder "dependencies", i.e. relationships that enforce possible or not possible states and attributes in the other tickets (i.e. B and C are parts of A,
so A can't be closed unless B and C are, or B blocking A makes A uncloseable ...), and in that is somewhat related to #443.

#20 - 2010-01-20 23:57 - Mischa The Evil

Felix Schafer wrote:

Hugo, you are right that what I'd call "lazy relationships", i.e. relationships that only link issues to one another and don't enforce anything (the
exception being follows/precedes), are implemented, and afaik that's what bugzilla has to offer to. This request has a broader scope though, and
calls for harder "dependencies”, i.e. relationships that enforce possible or not possible states and attributes in the other tickets (i.e. B and C are
parts of A, so A can't be closed unless B and C are, or B blocking A makes A uncloseable ...), and in that is somewhat related to #443.

Felix, please note r2800 which resolved issue #1740. This enhancement is included in Redmine 0.9.0 and makes it possible to actually prevent issues
from being set into statuses which are configured as being considered as closed when a 'blocked by’ relation is active for an issue which doesn't have
a status which isn't closed (yet). This will cover your examples as far as | can see... ;)

Regarding "This request has a broader scope though, and calls for harder "dependencies”, i.e. (...)" | do not agree. Due to the fact that this issue has
been opened almost 3 years ago the conclusion should be that it's scope was based on the Redmine functional-state 3 years ago (which didn't
include the feature of actually blocking issues from being set to a closed status when a 'blocked by' relation exists).

With the implementation of #1740 and the opening of #2448 for the additional, related "(Graphviz) dependency graph of related issues"-feature which
came up in the comments, this issue is resolved. Therefor I'll close it.

When more advanced feature-requests come-up | presume it's better to open new issues for it instead of keeping this issue open any longer
becoming more cluttered over time...

edit by Mischa The Evil on 2010-01-21 00:29

Kind regards,
Mischa.
#21 - 2010-01-21 00:23 - Mischa The Evil

- Status changed from New to Closed

- Resolution set to Fixed
As proposed in my previous comment on this issue.
#22 - 2010-01-21 00:25 - Mischa The Evil
Hugo Ferreira wrote:
David Leuschner wrote:
Redmine seems great, but as long as this feature is missing, (...)
| suspect its this issue log that is long due of an update, rather than the functionality being missing. I've just been evaluating Redmine version
0.9.0 and this works flawlessly:

(-]

Furthermore, the follows/precedes relationship will also touch the start/due dates according to the delay set.

Thanks for this info. I'll try to "port" this 'documentation’ clearly to the Redmine Guide.

#23 - 2010-01-21 09:14 - Felix Schéfer
Mischa The Evil wrote:
Felix, please note r2800 which resolved issue #1740. This enhancement is included in Redmine 0.9.0 and makes it possible to actually prevent

issues from being set into statuses which are configured as being considered as closed when a 'blocked by' relation is active for an issue which
doesn't have a status which isn't closed (yet). This will cover your examples as far as | can see... ;)

Oh, there you go, | try to keep up-to-date on the revisions, but that one seems to have crept under my radar :-) Anyway, | knew about the
end-date/start-date tie-up feature of the follows relationship, but not the close-blocking effect of the blocks relationship.

Long story short: the whole request is still not addressed, but | agree with you it's better to keep the more specific tickets open than this one.
https://www.redmine.org/projects/redmine/repository/svn/revisions/2800
https://www.redmine.org/versions/6
https://www.redmine.org/issues/2448
https://www.redmine.org/projects/redmine/wiki/Guide
#24 - 2010-06-30 16:54 - Howard Mall
- Status changed from Closed to Reopened

- Assignee set to Jean-Philippe Lang

Perhaps it is user error, but in the latest stable release (0.9.5) 'precedes’ and 'follows' relationships no longer effect 'Start' and 'Due date's for issues.
For example if | change the 'Due date' for 'Task 1.1" which 'precedes' 'Task 1.2', the 'Start' for Task 1.2 should shift accordingly. It no longer does this.

| checked it against the latest git clone this morning and this functional logic does not appear to work either.
| checked out the 0.9.0 release and those dependencies work as advertised.
Perhaps this is related to the sub-issue logic?

Redmine is proving very useful and we are eagerly awaiting the 1.0.0 release candidate on July 3, 2010. I'm hoping this defect can be resolved
before that release, because it is a really superb feature in 0.9.0.

#25 - 2010-07-01 15:35 - Felix Schéfer

- Status changed from Reopened to Closed

| can confirm this on r3813, but that needs to get in a new ticket. Howard, could you please open a new bug describing the regression? Thanks.
